unit xx15Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, StdCtrls, Grids, Menus;

const
  iFieldSize = 50;

type
  TMatchState = (msNone, msRed, msGreen);

  // Prvni slo udv dek, druh sloupec pro horizontln smr
  TMatchList = array[0..10, 1..10] of TMatchState;

  // Popoad X a Y
  TSquareList = array[1..10, 1..10] of TMatchState;

  TPlayer = record
    Name: ShortString;
    Score: Integer;
  end;

  TfrmMain = class(TForm)
    edtCount: TEdit;
    updCount: TUpDown;
    lblCount: TLabel;
    btnBegin: TButton;
    pnlPlayground: TPanel;
    ptbPlayground: TPaintBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lblScoGreen: TLabel;
    lblScoRed: TLabel;
    MainMenu1: TMainMenu;
    Showtopten1: TMenuItem;
    Help1: TMenuItem;
    Shape1: TShape;
    btnDemo: TButton;
    Timer1: TTimer;
    edtSpeed: TEdit;
    Label4: TLabel;
    UpDown1: TUpDown;
    btnSingle: TButton;
    procedure ptbPlaygroundPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnBeginClick(Sender: TObject);
    procedure ptbPlaygroundMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Showtopten1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure btnSingleClick(Sender: TObject);
    procedure UpDown1ChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    procedure btnDemoClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  public
    // Poet tverc na stran
    N: Integer;

    YetBegun: Boolean;

    // Zpalky ve vodorovnm a svislm smru
    HorizMatches, VertMatches: TMatchList;

    Squares: TSquareList;

    OnTurn: TMatchState;

    // Ovldn klvesnic
    Selection: Boolean;
    HorizSel: Boolean;
    SelI1, SelI2: Integer;

    // Top-ten
    TopTen: array[1..10] of TPlayer;
    PlayGreen: string;
    PlayRed: string;

    // Singleplayer
    Single: Boolean;
    Demo: Boolean;

    procedure VoidThePlayground;
    procedure PutDown(Horiz: Boolean; I1, I2: Integer);
    procedure CheckSquares;
    procedure CheckFinish;
  end;

var
  frmMain: TfrmMain;

implementation

uses xx15TopTen, xx15Names;

{$R *.DFM}

procedure TfrmMain.ptbPlaygroundPaint(Sender: TObject);
var
  I, J: Integer;
begin
  with ptbPlayground.Canvas do begin
    // Obarvm hrac pole blou barvou jako podklad
//        Brush.Color := clWhite;
  //  FillRect(Rect(0, 0, iFieldSize * N, iFieldSize * N));


    Pen.Color := clGray;
    Pen.Width := 0;
    // Vykreslm oddlovae tverc
    for I := 1 to N - 1 do begin
      // Svisl ra
      MoveTo(iFieldSize * I, 0);
      LineTo(iFieldSize * I, iFieldSize * N);

      // Vodorovn
      MoveTo(0, iFieldSize * I);
      LineTo(iFieldSize * N, iFieldSize * I);
    end;

    // Vykreslit keyboardfocus
    if Selection then begin
      Pen.Width := 5;
      Pen.Color := clBlue;

      if HorizSel then begin
        MoveTo((SelI2 - 1) * iFieldSize, SelI1 * iFieldSize);
        LineTo(SelI2 * iFieldSize, SelI1 * iFieldSize);
      end else begin
        MoveTo(SelI1 * iFieldSize, (SelI2 - 1) * iFieldSize);
        LineTo(SelI1 * iFieldSize, SelI2 * iFieldSize);
      end;
    end;

    Pen.Width := 3;
    // Vykreslit zpalky
    for I := 0 to 10 do for J := 1 to 10 do begin
      // Pesko przdn dky
      if HorizMatches[I, J] = msNone then
        Continue;

      if HorizMatches[I, J] = msRed then
        Pen.Color := clRed
      else
        Pen.Color := clGreen;

      MoveTo((J - 1) * iFieldSize, I * iFieldSize);
      LineTo(J * iFieldSize, I * iFieldSize);
    end;
    for I := 0 to 10 do for J := 1 to 10 do begin
      // Pesko przdn dky
      if VertMatches[I, J] = msNone then
        Continue;

      if VertMatches[I, J] = msRed then
        Pen.Color := clRed
      else
        Pen.Color := clGreen;

      MoveTo(I * iFieldSize, (J - 1) * iFieldSize);
      LineTo(I * iFieldSize, J * iFieldSize);
    end;

    // Vykreslit okupovan tverce
    for I := 1 to 10 do for J := 1 to 10 do begin
      if Squares[I, J] = msNone then
        Continue;

      if Squares[I, J] = msRed then
        Brush.Color := clRed
      else
        Brush.Color := clGreen;

      FillRect(Rect((I - 1) * iFieldSize, (J - 1) * iFieldSize, I * iFieldSize, J * iFieldSize));
    end;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  F: TFileStream;
begin
  Randomize;

  SelI1 := 1;
  SelI2 := 1;

  VoidThePlayground;
  N := 10;
  btnBeginClick(nil);

  // Load top-ten
  try
    F := TFileStream.Create('xx15topten.tpt', fmOpenRead);
    F.Read(TopTen, SizeOf(TopTen));
    F.Free;
  except
    on EFOpenError do;
    on Exception do raise;
  end;
end;

procedure TfrmMain.VoidThePlayground;
var
  I, J: Integer;
begin
  for I := 0 to 10 do for J := 1 to 10 do begin
    HorizMatches[I, J] := msNone;
    VertMatches[I, J] := msNone;
  end;

  for I := 1 to 10 do for J := 1 to 10 do begin
    Squares[I, J] := msNone;
  end;

  ptbPlayground.Invalidate;
end;

procedure TfrmMain.btnBeginClick(Sender: TObject);
begin
  Single := False;
  Demo := False;

  // Pipravit podmnky
  N := updCount.Position;
  VoidThePlayground;

  pnlPlayground.Width := N * iFieldSize + 6;
  pnlPlayground.Height := N * iFieldSize + 6;

  OnTurn := msRed;

  // Ask the names
  if Sender <> nil then
  with TfrmNames.Create(Self) do try
    if ShowModal = mrOK then begin
      btnBegin.Enabled := False;
      edtCount.Enabled := False;
      btnSingle.Enabled := False;
      btnDemo.Enabled := False;
      updCount.Enabled := False;
      YetBegun := True;

      PlayRed := edtRed.Text;
      PlayGreen := edtGreen.Text;
    end;
  finally
    Free;
  end;
end;

procedure TfrmMain.ptbPlaygroundMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Row, Col: Integer;
  I1, I2: Integer;
  Horiz: Boolean;
begin
  if not YetBegun then Exit;

  // Pouze lev tlatko
  if Button <> mbLeft then
    Exit;

  Horiz := (Round(Y / (iFieldSize div 2)) mod 2) = 0;

  Col := Round(X / iFieldSize);
  Row := Round(Y / iFieldSize);

  if Horiz then begin
    I1 := Row;
    I2 := X div iFieldSize + 1;
    PutDown(True, I1, I2);
  end else begin
    I1 := Col;
    I2 := Y div iFieldSize + 1;
    PutDown(False, I1, I2);
  end;
end;

procedure TfrmMain.PutDown(Horiz: Boolean; I1, I2: Integer);
var
  Turn: Boolean;
begin
  Turn := False;

  if Horiz then
    if HorizMatches[I1, I2] = msNone then begin
      HorizMatches[I1, I2] := OnTurn;
      Turn := True;
    end else
  else
    if VertMatches[I1, I2] = msNone then begin
      VertMatches[I1, I2] := OnTurn;
      Turn := True;
    end;

  if Turn then begin
    CheckSquares;
    ptbPlayground.Invalidate;
    if OnTurn = msRed then begin
      OnTurn := msGreen;
      Shape1.Brush.Color := clGreen;
    end else begin
      OnTurn := msRed;
      Shape1.Brush.Color := clRed;
    end;
  end;

  if Single and (OnTurn = msGreen) then
    Help1.Click;
end;

procedure TfrmMain.CheckSquares;
var
  I, J: Integer;
  Red, Green: Integer;
begin
  Red := 0; Green := 0;
  for I := 1 to 10 do for J := 1 to 10 do begin
    if (HorizMatches[I - 1, J] = HorizMatches[I, J]) and
       (HorizMatches[I - 1, J] = VertMatches[J - 1, I]) and
       (HorizMatches[I - 1, J] = VertMatches[J, I]) then
    begin
      Squares[J, I] := HorizMatches[I - 1, J];
      if HorizMatches[I - 1, J] = msGreen then
        Green := Green + 1;
      if HorizMatches[I - 1, J] = msRed then
        Red := Red + 1;
    end else
      Squares[J, I] := msNone;
  end;

  if (StrToInt(lblScoGreen.Caption) <> Green) or (StrToInt(lblScoRed.Caption) <> Red) then begin
    lblScoGreen.Caption := IntToStr(Green);
    lblScoRed.Caption := IntToStr(Red);
    if OnTurn = msRed then begin
      OnTurn := msGreen;
      Shape1.Brush.Color := clGreen;
    end else begin
      OnTurn := msRed;
      Shape1.Brush.Color := clRed;
    end;
  end;

  CheckFinish;
end;

procedure TfrmMain.FormKeyPress(Sender: TObject; var Key: Char);
var
 NUll: Boolean;
 Pom: Integer;
begin
  if not YetBegun then Exit;

  if Key = #13 then begin
    Selection := not Selection;
    ptbPlayground.Invalidate;
    Key := #0;
    Exit;
  end;

  Null := True;

  case Key of
    's':
      if HorizSel then
        if SelI1 < 10 then SelI1 := SelI1 + 1 else
      else
        if SelI2 < 10 then SelI2 := SelI2 + 1;
    'w':
      if HorizSel then
        if SelI1 > 0 then SelI1 := SelI1 - 1 else
      else
        if SelI2 > 1 then SelI2 := SelI2 - 1;
    'a':
      if HorizSel then
        if SelI2 > 1 then SelI2 := SelI2 - 1 else
      else
        if SelI1 > 0 then SelI1 := SelI1 - 1;
    'd':
      if HorizSel then
        if SelI2 < 10 then SelI2 := SelI2 + 1 else
      else
        if SelI1 < 10 then SelI1 := SelI1 + 1;
    ' ': begin
      HorizSel := not HorizSel;
      Pom := SelI1;
      SelI1 := SelI2;
      SelI2 := Pom;
      if SelI2 < 1 then SelI2 := 1;
    end;
    'q': PutDown(HorizSel, SelI1, SelI2);

  else
    Null := False;
  end;

  if Null then begin
    ptbPlayground.Invalidate;
    Key := #0;
  end;
end;

procedure TfrmMain.CheckFinish;
var
  I, J: Integer;
  ScoGreen, ScoRed: Integer;
  Moved: Boolean;
begin
  for I := 0 to N do for J := 1 to N do
    if HorizMatches[I, J] = msNone then Exit;

  for I := 0 to N do for J := 1 to N do
    if VertMatches[I, J] = msNone then Exit;

  ScoGreen := StrToInt(lblScoGreen.Caption);
  ScoRed := StrToInt(lblScoRed.Caption);

  if TopTen[10].Score < ScoGreen then begin
    Moved := False;
    for I := 10 downto 1 do begin
      if (TopTen[I].Name = PlayGreen) then
        if (TopTen[I].Score < ScoGreen) then begin
          Moved := True;
          Break;
        end else begin
          for J := I to 9 do
            TopTen[J] := TopTen[J + 1];
        end;
      if TopTen[I].Score >= ScoGreen then begin
        // Posunout vechny hor o jednu dol
        for J := 9 downto I + 1 do
          TopTen[J + 1] := TopTen[J];

        TopTen[I + 1].Name := PlayGreen;
        TopTen[I + 1].Score := ScoGreen;
        Moved := True;
      end;
    end;
    if not Moved then
      TopTen[1].Name := PlayGreen;
      TopTen[1].Score := ScoGreen;
  end;

  if TopTen[10].Score < ScoRed then begin
    Moved := False;
    for I := 10 downto 1 do begin
      if (TopTen[I].Name = PlayRed) then
        if (TopTen[I].Score < ScoRed) then begin
          Moved := True;
          Break;
        end else begin
          for J := I to 9 do
            TopTen[J] := TopTen[J + 1];
        end;
      if TopTen[I].Score >= ScoRed then begin
        // Posunout vechny hor o jednu dol
        for J := 9 downto I + 1 do
          TopTen[J + 1] := TopTen[J];

        TopTen[I + 1].Name := PlayRed;
        TopTen[I + 1].Score := ScoRed;
        Moved := True;
      end;
    end;
    if not Moved then
      TopTen[1].Name := PlayRed;
      TopTen[1].Score := ScoRed;
  end;
  btnBegin.Enabled := True;
  edtCount.Enabled := True;
  btnSingle.Enabled := True;
  btnDemo.Enabled := True;
  updCount.Enabled := True;
  YetBegun := False;
  Timer1.Enabled := False;

  MessageDlg('Konec hry', mtInformation, [mbOK], 0);
end;

procedure TfrmMain.Showtopten1Click(Sender: TObject);
begin
  with TfrmTopTen.Create(Self) do try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
var
  F: TFileStream;
begin
  try
    F := TFileStream.Create('xx15topten.tpt', fmCreate);
    F.Write(TopTen, SizeOf(TopTen));
    F.Free;
  except
    on EFOpenError do;
    on Exception do raise;
  end;
end;

procedure TfrmMain.Help1Click(Sender: TObject);
var
  I, J: Integer;
  Rev: TMatchState;
  Max, Count: Integer;
  Curr: Integer;
  Rnd: Integer;
  Done: Boolean;
begin
  if (not YetBegun) and (not Demo) then Exit;
  // Vybere nhodn tverec s co nejvtm potem svch a dnm cizm
  // sirek. Pak umst nhodn sirku

  if OnTurn = msRed then
    Rev := msGreen
  else
    Rev := msRed;

  Max := 0;
  Count := 0;

  for I := 1 to N do for J := 1 to N do begin
      Curr := 0;
      if (HorizMatches[I - 1, J] <> Rev) and
         (HorizMatches[I, J] <> Rev) and
         (VertMatches[J - 1, I] <> Rev) and
         (VertMatches[J, I] <> Rev) then
      begin
        if HorizMatches[I - 1, J] = OnTurn then Inc(Curr);
        if HorizMatches[I, J] = OnTurn then Inc(Curr);
        if VertMatches[J - 1, I] = OnTurn then Inc(Curr);
        if VertMatches[J, I] = OnTurn then Inc(Curr);

        if Curr <> 4 then begin
          if Max < Curr then begin
            Max := Curr;
            Count := 0;
          end;
          if Max = Curr then Inc(Count);
        end;
      end;

  end;

  Rnd := Random(Count);

    Done := False;
    for I := 1 to N do begin
    for J := 1 to N do begin
      if (HorizMatches[I - 1, J] <> Rev) and
         (HorizMatches[I, J] <> Rev) and
         (VertMatches[J - 1, I] <> Rev) and
         (VertMatches[J, I] <> Rev) then
      begin
        Curr := 0;
        if HorizMatches[I - 1, J] = OnTurn then Inc(Curr);
        if HorizMatches[I, J] = OnTurn then Inc(Curr);
        if VertMatches[J - 1, I] = OnTurn then Inc(Curr);
        if VertMatches[J, I] = OnTurn then Inc(Curr);

        if Curr = Max then
          if Rnd = 0 then begin
            if HorizMatches[I - 1, J] = msNone then begin
              PutDown(True, I - 1, J);
              Done := True;
              Break;
            end;
            if VertMatches[J - 1, I] = msNone then begin
              PutDown(False, J - 1, I);
              Done := True;
              Break;
            end;
            if HorizMatches[I, J] = msNone then begin
              PutDown(True, I, J);
              Done := True;
              Break;
            end;
            if VertMatches[J, I] = msNone then begin
              PutDown(False, J, I);
              Done := True;
              Break;
            end;
          end else
            Rnd := Rnd - 1;
      end;
    end;
    if Done then Break;
    end;

    if not Done then begin
      for I := 0 to N do for J := 1 to N do begin
        if HorizMatches[I, J] = msNone then begin
          PutDown(True, I, J);
          Break;
        end;
        if VertMatches[I, J] = msNone then begin
          PutDown(False, I, J);
          Break;
        end;
      end;
    end;
end;

procedure TfrmMain.btnSingleClick(Sender: TObject);
begin
  btnBegin.Click;
  Single := True;
end;

procedure TfrmMain.UpDown1ChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  Timer1.Interval := NewValue;
end;

procedure TfrmMain.btnDemoClick(Sender: TObject);
begin
  btnBegin.Click;
  YetBegun := False;
  Demo := True;
  Timer1.Enabled := True;
end;

procedure TfrmMain.Timer1Timer(Sender: TObject);
begin
  Help1.Click;
end;

end.

